<template>
  <v-layout color="#f8f8f8">
    <v-flex md12 pa-1>
      <v-layout>
        <v-card class="mx-auto my-12" elevation="0" width="100%" height="100%">
          <v-layout v-if="!mobileView">
            <v-flex xs4>
              <div class="font-size-24-bold title-style">
                ประวัติการทำรายการ
              </div>
            </v-flex>
            <v-flex
              xs3
              style="margin: 16px 8px 16px 0px;font-family: Sarabun, sans-serif;"
            >
              <v-text-field
                outline
                placeholder="Search"
                name="search"
                v-model="alltransactionsearch"
                append-icon="search"
                style="width:100%"
              >
              </v-text-field>
            </v-flex>
            <v-flex xs3 style="display: flex;justify-content: center;">
              <v-btn
                outline
                class="btn-advanced-search"
                @click="btnAdvancedSearch()"
              >
                Advanced search
                <img
                  :src="images.down"
                  style="width: 24px;margin-left: 4px;"
                  v-if="advancedstatus == false"
                />
                <img
                  :src="images.arrow"
                  style="width: 24px;margin-left: 4px;"
                  v-if="advancedstatus == true"
                />
              </v-btn>
            </v-flex>
            <v-spacer></v-spacer>
            <v-flex xs2 style="display: flex;justify-content: center;">
              <v-btn class="btn-export" @click="onExport()">
                Export to Excel
              </v-btn>
            </v-flex>
          </v-layout>

          <!-- ------------------------- mobileView ------------------------- -->
          <v-layout wrap v-if="mobileView">
            <v-flex xs="6">
              <div class="font-size-24-bold title-style">
                ประวัติการทำรายการ
              </div>
            </v-flex>
            <v-flex xs="6" style="margin: 16px 8px 16px 0px;">
              <v-text-field
                outline
                placeholder="Search"
                name="search"
                v-model="alltransactionsearch"
                append-icon="search"
                style="width:95%"
              >
              </v-text-field>
            </v-flex>

            <v-flex xs="6" style="display: flex;justify-content: center;">
              <v-btn
                outline
                class="btn-advanced-search"
                @click="btnAdvancedSearch()"
              >
                Advanced search
                <img
                  :src="images.down"
                  style="width: 24px;margin-left: 4px;"
                  v-if="advancedstatus == false"
                />
                <img
                  :src="images.arrow"
                  style="width: 24px;margin-left: 4px;"
                  v-if="advancedstatus == true"
                />
              </v-btn>
            </v-flex>
            <v-flex xs="6" style="display: flex;justify-content: center;">
              <v-btn class="btn-export" @click="onExport()">
                Export to Excel
              </v-btn>
            </v-flex>
          </v-layout>
          <!-- ------------------------- end mobileView ------------------------- -->

          <div class="box-advanced" v-if="advancedstatus == true">
            <v-layout>
              <v-flex xs3 style="margin: 24px 8px 8px 24px;">
                <span class="text">Receiver Account Name</span>
                <v-text-field
                  outline
                  name="receiveraccountname"
                  v-model="receiveraccountname"
                ></v-text-field>
              </v-flex>
              <v-flex xs3 style="margin: 24px 8px 8px 8px;">
                <span class="text">Grand Total</span>
                <v-text-field
                  outline
                  name="grandtotal"
                  v-model="grandtotal"
                ></v-text-field>
              </v-flex>
              <v-flex xs3 style="margin: 24px 8px 8px 8px;">
                <span class="text">Receiver Bank Code</span>
                <v-text-field
                  outline
                  name="receiverbankcode"
                  v-model="receiverbankcode"
                ></v-text-field>
              </v-flex>
              <v-flex xs3 style="margin: 24px 8px 8px 8px;">
                <span class="text">Receiver Tax ID</span>
                <v-text-field
                  outline
                  name="receivertaxid"
                  v-model="receivertaxid"
                ></v-text-field>
              </v-flex>
            </v-layout>

            <v-layout>
              <v-flex xs3 style="margin: 8px 8px 8px 24px;">
                <span class="text">Detail</span>
                <v-text-field
                  outline
                  name="detail"
                  v-model="detail"
                ></v-text-field>
              </v-flex>
              <v-flex xs3 style="margin: 8px;">
                <span class="text">Transfer to Receiver</span>
                <v-select
                  outline
                  :items="items"
                  name="transferprocessing"
                  v-model="transferprocessing"
                ></v-select>
              </v-flex>
              <v-flex xs3 style="margin: 8px;">
                <span class="text">Transfer to RD</span>
                <v-select
                  outline
                  :items="items"
                  name="rdprocessing"
                  v-model="rdprocessing"
                ></v-select>
              </v-flex>
              <v-flex xs3 style="margin: 8px;">
                <span class="text">Payment Date</span>

                <v-menu
                  v-model="menu"
                  :close-on-content-click="false"
                  :nudge-left="100"
                  transition="scale-transition"
                  offset-y
                  min-width="auto"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      outline
                      :value="computedDateFormattedMomentjs"
                      v-model="date"
                      append-icon="mdi-calendar"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    no-title
                    color="green lighten-1"
                    v-model="date"
                    @input="menu = false"
                  ></v-date-picker>
                </v-menu>
              </v-flex>
            </v-layout>
            <v-layout style="display: flex;justify-content: flex-end;">
              <v-btn outline class="btn-reset" @click="reset()">
                Reset
              </v-btn>
            </v-layout>
          </div>
        </v-card>
      </v-layout>

      <!-- <v-flex xs4 v-if="!mobileView"></v-flex> -->
      <!-- <v-flex xs1 py-3 px-5 v-if="!mobileView">
        <v-btn
          flat small
          @click="exportmodal = true"
          color="grey"
          class="white--text">EXPORT
          <v-icon color="blue-grey">mdi-download</v-icon>
          </v-btn>
      </v-flex> -->
      <!-- <v-flex xs1 v-if="!mobileView"></v-flex>
        <v-flex xs5 align-center py-3 v-if="!mobileView">
          <v-text-field
            color="#6a7d69"
            solo
            light
            label="search"
            hide-details
            v-model="alltransactionsearch"
            append-icon="search"
          >
          </v-text-field>
        </v-flex> -->

      <!-- <v-layout>
        <v-flex xs12 align-center v-if="mobileView">
          <v-text-field
            color="#6a7d69"
            solo
            light
            label="search"
            hide-details
            v-model="alltransactionsearch"
            append-icon="search"
            style="padding-top:10px;"
          >
          </v-text-field>
        </v-flex>
      </v-layout> -->
      <!-- <v-layout v-if="mobileView">
        <v-flex xs10></v-flex> -->
      <!-- <v-flex xs2 align-center >
          <v-btn
          flat icon small
          @click="exportmodal = true"
          color="grey"
          class="white--text">EXPORT
          <v-icon color="blue-grey">mdi-download</v-icon>
          </v-btn>
      </v-flex> -->
      <!-- </v-layout> -->
      <v-card elevation="0">
        <v-flex xs12 pa-1>
          <v-data-table
            :rows-per-page-items="rowperpage"
            :pagination.sync="pagination"
            class="elevation-0 table-style"
            :headers="headers"
            :items="transview"
            :search="alltransactionsearch"
            :loading="istableloading"
            v-if="!mobileView"
            id="mytable"
            disable-initial-sort
          >
            <template v-slot:items="props">
              <tr style="cursor: pointer;" @click="openDialogDetail(props)">
                <!-- <td class="text-xs-left">{{ props.item.order_id }}</td>
                <td class="text-xs-left">{{ props.item.due_date }}</td>
                <td
                  class="text-xs-left"
                  style="min-width:200px;max-width: 200px;"
                >
                  {{ props.item.detail }}
                </td> -->
                <td class="text-xs-left">
                  {{ props.item.payment_no }}
                </td>
                <td class="text-xs-left">
                  {{ props.item.receiver_company }}
                </td>
                <td class="text-xs-left">{{ props.item.payment_date }}</td>
                <td class="text-xs-left">
                  <v-chip
                    label
                    disabled
                    :color="setStatusColor(props.item.transfer_processing)"
                    :text-color="setTextColor(props.item.transfer_processing)"
                    text-font="center"
                    style="width:90px; justify-content: center;font-weight:bold"
                    >{{ props.item.transfer_processing }}</v-chip
                  >
                </td>
                <!-- <td class="text-xs-center">
                  <v-chip
                    label
                    disabled
                    :color="setStatusColor(props.item.rd_processing)"
                    :text-color="setTextColor(props.item.rd_processing)"
                    text-font="center"
                    style="width:90px; justify-content: center;font-weight:bold"
                    >{{ props.item.rd_processing }}</v-chip
                  >
                </td>
                <td class="text-xs-left">{{ props.item.receiver_tax_id }}</td>
                <td class="text-xs-left">
                  {{ props.item.receiver_account_no }}
                </td>
                <td class="text-xs-left">
                  {{ props.item.receiver_bankcode }}
                </td>
                <td class="text-xs-left">{{ props.item.receiver_email }}</td>
                <td class="text-xs-left">{{ props.item.income_type }}</td> -->
                <td class="text-xs-right">
                  {{ props.item.pay_amount }}
                </td>
                <!-- <td class="text-xs-left">{{ props.item.vat_amount }}</td>
                <td class="text-xs-left">{{ props.item.grand_total }}</td>
                <td class="text-xs-left">{{ props.item.wht_rate }} %</td>
                <td class="text-xs-left">{{ props.item.wht_amount }}</td>
                <td class="text-xs-left">{{ props.item.payer_tax_id }}</td> -->
                <!-- <td class="text-xs-center">{{ props.item.payment_time }}</td> -->

                <!-- --------------------- Dialog Resend --------------------- -->
                <td class="text-xs-center" style="cursor: pointer;">
                  <v-dialog v-model="dialog" persistent max-width="600px">
                    <template v-slot:activator="{ on, attrs }">
                      <div
                        v-if="
                          props.item.transfer_processing == 'Rejected' &&
                            role == 'User'
                        "
                      >
                        <v-btn
                          outline
                          class="btn-resend"
                          v-bind="attrs"
                          v-on="on"
                          @click="
                            resend(
                              props.item.order_id,
                              props.item.payment_no,
                              props.item.receiver_account_name,
                              props.item.receiver_account_no,
                              props.item.receiver_bankcode
                            )
                          "
                        >
                          Resend
                        </v-btn>
                      </div>
                      <div v-else></div>
                    </template>
                    <v-card>
                      <v-form v-model="isFormValid">
                        <v-card-title>
                          <span class="title">Payment No: {{ pvno }}</span>
                        </v-card-title>
                        <v-card-text>
                          <v-container>
                            <v-layout class="text-dialog">
                              <v-flex>
                                <span
                                  >Receiver Account Name
                                  <span class="red--text">*</span></span
                                >
                                <v-text-field
                                  outline
                                  name="name"
                                  v-model="name"
                                  :rules="[
                                    () => !!name || 'This field is required',
                                    () =>
                                      /^[a-zA-Z\s]+$/.test(name) ||
                                      'Name must be character'
                                  ]"
                                ></v-text-field>
                              </v-flex>
                            </v-layout>
                            <v-layout class="text-dialog">
                              <v-flex xs="6" style="padding-right: 10px;">
                                <span
                                  >Receiver Account No
                                  <span class="red--text">*</span></span
                                >
                                <v-text-field
                                  outline
                                  name="account_no"
                                  v-model="account_no"
                                  :rules="[
                                    () =>
                                      !!account_no || 'This field is required'
                                  ]"
                                >
                                </v-text-field>
                              </v-flex>
                              <v-flex xs="6">
                                <span
                                  >Receiver Bank Code
                                  <span class="red--text">*</span></span
                                >
                                <v-text-field
                                  outline
                                  name="bankcode"
                                  v-model="bankcode"
                                  :rules="[
                                    () => !!bankcode || 'This field is required'
                                  ]"
                                >
                                </v-text-field>
                              </v-flex>
                            </v-layout>
                          </v-container>
                        </v-card-text>
                        <v-card-actions>
                          <v-spacer></v-spacer>
                          <v-btn
                            outline
                            class="btn-reset"
                            text
                            @click="dialog = false"
                          >
                            Close
                          </v-btn>
                          <v-btn
                            class="btn-save"
                            text
                            @click="onSave()"
                            :disabled="!isFormValid"
                          >
                            Save
                          </v-btn>
                        </v-card-actions>
                      </v-form>
                    </v-card>
                  </v-dialog>
                </td>
                <!-- --------------------- End Dialog Resend --------------------- -->
              </tr>
            </template>
          </v-data-table>

          <!-- mobile -->
          <v-data-table
            :rows-per-page-items="rowperpage"
            :pagination.sync="pagination"
            class="elevation-0 table-style"
            :headers="headers"
            :items="transview"
            :search="alltransactionsearch"
            :loading="istableloading"
            v-if="mobileView"
            id="mytable"
          >
            <template v-slot:items="props">
              <tr
                @click="
                  openDialogDetail(props), opentransactionmodal(props.item.id)
                "
                style="cursor: pointer;"
              >
                <!-- <td class="text-xs-left">{{ props.item.order_id }}</td>
                <td class="text-xs-left">{{ props.item.due_date }}</td>
                <td
                  class="text-xs-left"
                  style="min-width:200px;max-width: 200px;"
                >
                  {{ props.item.detail }}
                </td> -->
                <td class="text-xs-left">
                  {{ props.item.payment_no }}
                </td>
                <td class="text-xs-left">
                  {{ props.item.receiver_company }}
                </td>
                <td class="text-xs-left">{{ props.item.payment_date }}</td>
                <td class="text-xs-left">
                  <v-chip
                    label
                    disabled
                    :color="setStatusColor(props.item.transfer_processing)"
                    :text-color="setTextColor(props.item.transfer_processing)"
                    text-font="center"
                    style="width:90px; justify-content: center;font-weight:bold"
                    >{{ props.item.transfer_processing }}</v-chip
                  >
                </td>
                <!-- <td class="text-xs-center">
                  <v-chip
                    label
                    disabled
                    :color="setStatusColor(props.item.rd_processing)"
                    :text-color="setTextColor(props.item.rd_processing)"
                    text-font="center"
                    style="width:90px; justify-content: center;font-weight:bold"
                    >{{ props.item.rd_processing }}</v-chip
                  >
                </td>
                <td class="text-xs-left">{{ props.item.receiver_tax_id }}</td>
                <td class="text-xs-left">
                  {{ props.item.receiver_account_no }}
                </td>
                <td class="text-xs-left">
                  {{ props.item.receiver_bankcode }}
                </td>
                <td class="text-xs-left">{{ props.item.receiver_email }}</td>
                <td class="text-xs-left">{{ props.item.income_type }}</td> -->
                <td class="text-xs-right">
                  {{ props.item.pay_amount }}
                </td>
                <!-- <td class="text-xs-left">{{ props.item.vat_amount }}</td>
                <td class="text-xs-left">{{ props.item.grand_total }}</td>
                <td class="text-xs-left">{{ props.item.wht_rate }} %</td>
                <td class="text-xs-left">{{ props.item.wht_amount }}</td>
                <td class="text-xs-left">{{ props.item.payer_tax_id }}</td> -->
                <!-- <td class="text-xs-center">{{ props.item.payment_time }}</td> -->

                <!-- --------------------- Dialog Resend --------------------- -->
                <td class="text-xs-center" style="cursor: pointer;">
                  <v-dialog v-model="dialog" persistent max-width="600px">
                    <template v-slot:activator="{ on, attrs }">
                      <div
                        v-if="
                          props.item.transfer_processing == 'Rejected' &&
                            role == 'User'
                        "
                      >
                        <!-- <v-btn>resend</v-btn> -->
                        <v-btn
                          outline
                          class="btn-resend"
                          v-bind="attrs"
                          v-on="on"
                          @click="
                            resend(
                              props.item.order_id,
                              props.item.payment_no,
                              props.item.receiver_account_name,
                              props.item.receiver_account_no,
                              props.item.receiver_bankcode
                            )
                          "
                        >
                          Resend
                        </v-btn>
                      </div>
                      <div v-else></div>
                    </template>
                    <v-card>
                      <v-form v-model="isFormValid">
                        <v-card-title>
                          <span class="title">Payment No: {{ pvno }}</span>
                        </v-card-title>
                        <v-card-text>
                          <v-container>
                            <v-layout class="text-dialog">
                              <v-flex>
                                <span
                                  >Receiver Account Name
                                  <span class="red--text">*</span></span
                                >
                                <v-text-field
                                  outline
                                  name="name"
                                  v-model="name"
                                  :rules="[
                                    () => !!name || 'This field is required',
                                    () =>
                                      /^[a-zA-Z\s]+$/.test(name) ||
                                      'Name must be character'
                                  ]"
                                ></v-text-field>
                              </v-flex>
                            </v-layout>
                            <v-layout class="text-dialog">
                              <v-flex xs="6" style="padding-right: 10px;">
                                <span
                                  >Receiver Account No
                                  <span class="red--text">*</span></span
                                >
                                <v-text-field
                                  outline
                                  name="account_no"
                                  v-model="account_no"
                                  :rules="[
                                    () =>
                                      !!account_no || 'This field is required'
                                  ]"
                                >
                                </v-text-field>
                              </v-flex>
                              <v-flex xs="6">
                                <span
                                  >Receiver Bank Code
                                  <span class="red--text">*</span></span
                                >
                                <v-text-field
                                  outline
                                  name="bankcode"
                                  v-model="bankcode"
                                  :rules="[
                                    () => !!bankcode || 'This field is required'
                                  ]"
                                >
                                </v-text-field>
                              </v-flex>
                            </v-layout>
                          </v-container>
                        </v-card-text>
                        <v-card-actions>
                          <v-spacer></v-spacer>
                          <v-btn
                            outline
                            class="btn-reset"
                            text
                            @click="dialog = false"
                          >
                            Close
                          </v-btn>
                          <v-btn
                            class="btn-save"
                            text
                            @click="onSave()"
                            :disabled="!isFormValid"
                          >
                            Save
                          </v-btn>
                        </v-card-actions>
                      </v-form>
                    </v-card>
                  </v-dialog>
                </td>
                <!-- --------------------- End Dialog Resend --------------------- -->
              </tr>
            </template>
          </v-data-table>
          <!-- end mobile -->
        </v-flex>
      </v-card>
    </v-flex>

    <!-- --------------------- Detail Dialog -------------------------- -->
    <v-dialog v-model="detail_dialog" fullscreen hide-overlay>
      <v-card>
        <v-card-title>
          <span class="title">Payment No: {{ d_payno }}</span>
          <v-spacer></v-spacer>
          <v-btn
            class="btn-resend2"
            v-if="d_transfer_processing == 'Rejected' && role == 'User'"
            @click="openDialogResend()"
            >Resend</v-btn
          >
          <v-btn icon @click="closeDetailDialog()">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-card-title>
        <v-card-text>
          <v-container style="margin-top: -30px">
            <v-layout class="text-dialog">
              <v-flex xs3>
                <span class="text-head">Payment Number</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_payno }}</span>
              </v-flex>
              <v-flex xs3>
                <span class="text-head">Document Number </span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_docno }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Transfer Status </span>
              </v-flex>
              <v-flex>
                <span>{{ d_transfer_processing }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Receiver Company</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_receiver_company }}</span>
              </v-flex>
              <v-flex xs3>
                <span class="text-head">Receiver Tax ID</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_receiver_tax_id }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Amount</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_amount_exc_vat }}</span>
              </v-flex>
              <v-flex xs3>
                <span class="text-head">VAT</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_vat_amount }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">WHT</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_wht_amount }}</span>
              </v-flex>
              <v-flex xs3>
                <span class="text-head">WHT Rate (%)</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_wht_rate }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Pay Amount</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_pay_amount }}</span>
              </v-flex>
              <v-flex xs3>
                <span class="text-head">Payment Date</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_payment_date }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Type of Income</span>
              </v-flex>
              <v-flex>
                <span>{{ d_income_type }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Detail</span>
              </v-flex>
              <v-flex>
                <span>{{ d_detail }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Receiver Account Name </span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_receiver_account_name }}</span>
              </v-flex>
              <v-flex xs3>
                <span class="text-head">Receiver Account No </span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_receiver_account_no }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Receiver Bank Code </span>
              </v-flex>
              <v-flex>
                <span>{{ d_receiver_bankcode }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Receiver Email </span>
              </v-flex>
              <v-flex>
                <span>{{ d_receiver_email }}</span>
              </v-flex>
            </v-layout>
          </v-container>
        </v-card-text>

        <!-- <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn outline class="btn-reset" text @click="closeDetailDialog()">
            Close
          </v-btn>
        </v-card-actions> -->
      </v-card>
    </v-dialog>
    <!-- --------------------- End Detail Dialog -------------------------- -->

    <!-- --------------------- Resend from Detail Dialog --------------------- -->
    <v-dialog v-model="resend_dialog" persistent max-width="600px">
      <v-card>
        <v-form v-model="isFormValid">
          <v-card-title>
            <span class="title">Payment No: {{ d_payno }}</span>
          </v-card-title>
          <v-card-text>
            <v-container>
              <v-layout class="text-dialog">
                <v-flex>
                  <span
                    >Receiver Account Name
                    <span class="red--text">*</span></span
                  >
                  <v-text-field
                    outline
                    name="name"
                    v-model="name"
                    :rules="[
                      () => !!name || 'This field is required',
                      () =>
                        /^[a-zA-Z\s]+$/.test(name) || 'Name must be character'
                    ]"
                  ></v-text-field>
                </v-flex>
              </v-layout>
              <v-layout class="text-dialog">
                <v-flex xs="6" style="padding-right: 10px;">
                  <span
                    >Receiver Account No <span class="red--text">*</span></span
                  >
                  <v-text-field
                    outline
                    name="account_no"
                    v-model="account_no"
                    :rules="[() => !!account_no || 'This field is required']"
                  >
                  </v-text-field>
                </v-flex>
                <v-flex xs="6">
                  <span
                    >Receiver Bank Code <span class="red--text">*</span></span
                  >
                  <v-text-field
                    outline
                    name="bankcode"
                    v-model="bankcode"
                    :rules="[() => !!bankcode || 'This field is required']"
                  >
                  </v-text-field>
                </v-flex>
              </v-layout>
            </v-container>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn
              outline
              class="btn-reset"
              text
              @click="resend_dialog = false"
            >
              Close
            </v-btn>
            <v-btn
              class="btn-save"
              text
              @click="onSave()"
              :disabled="!isFormValid"
            >
              Save
            </v-btn>
          </v-card-actions>
        </v-form>
      </v-card>
    </v-dialog>
    <!-- --------------------- End Resend from Detail Dialog --------------------- -->

    <!-- <Transactionmodal /> -->
    <Exportmodal />
  </v-layout>
</template>
<script>
import { sync } from "vuex-pathify";
import moment from "moment";
import XLSX from "xlsx";
import Swal from "sweetalert2";
// import jsPDF from 'jspdf'
import Exportmodal from "@/components/Exportmodal";
moment.locale("en");
export default {
  components: {
    Exportmodal
  },
  data() {
    return {
      role: this.$cookies.get("role"),
      selectedMonth: "",
      dialogexport: false,
      mobileView: "",
      istableloading: false,
      alltransactionsearch: "",
      alltransactions: [],
      custName: this.$cookies.get("custName"),
      headers: [
        // { text: "Doc No.", value: "order_id", align: "left" },
        // { text: "Doc Date", value: "due_date", align: "left" },
        // { text: "Detail", value: "detail", align: "left" },
        {
          text: "Payment No.",
          value: "payment_no",
          align: "left"
        },
        {
          text: "Receiver Company",
          value: "receiver_company",
          align: "left"
        },
        { text: "Transfer Date Time", value: "payment_date", align: "left" },
        {
          text: "Transfer Status",
          value: "transfer_processing",
          align: "left"
        },
        {
          text: "Transfer Amount",
          value: "pay_amount",
          align: "center"
        },
        {
          text: "Action",
          value: "action",
          align: "center"
        }
        // {
        //   text: "Transfer to Receiver",
        //   value: "transfer_processing",
        //   align: "left"
        // },

        // { text: "Receiver Tax ID", value: "receiver_tax_id", align: "left" },
        // {
        //   text: "Receiver Account No",
        //   value: "receiver_account_no",
        //   align: "left"
        // },
        // {
        //   text: "Receiver Bank Code",
        //   value: "receiver_bankcode",
        //   align: "left"
        // },
        // { text: "Receiver Email", value: "receiver_email", align: "left" },
        // { text: "Income Type", value: "income_type", align: "left" },

        // { text: "VAT", value: "vat_amount", align: "left" },
        // { text: "Grand Total", value: "grand_total", align: "left" },
        // { text: "WHT Rate (%)", value: "wht_rate", align: "left" },
        // { text: "WHT", value: "wht_amount", align: "left" },
        // { text: "Sender TAX ID", value: "payer_tax_id", align: "left" },
        // { text: "Payment Time", value: "payment_time", align: "left" },
      ],
      rowperpage: [
        5,
        10,
        25,
        { text: "$vuetify.dataIterator.rowsPerPageAll", value: -1 }
      ],
      pagination: {
        rowsPerPage: 10
      },
      images: {
        arrow: require("../assets/icon/arrow.png"),
        down: require("../assets/icon/down.png")
      },
      items: ["Completed", "In process", "Rejected"],
      // date: new Date().toISOString().substr(0, 10),
      date: "",
      menu: false,
      advancedstatus: false,
      receiveraccountname: "",
      grandtotal: "",
      receiverbankcode: "",
      receivertaxid: "",
      detail: "",
      transferprocessing: "",
      rdprocessing: "",
      dialog: false,
      detail_dialog: false,
      resend_dialog: false,
      pvno: "",
      payment_no: "",
      name: "",
      account_no: "",
      bankcode: "",
      isFormValid: false,

      // dialog detail
      d_payno: "",
      d_docno: "",
      d_transfer_processing: "",
      d_receiver_company: "",
      d_receiver_tax_id: "",
      d_amount_exc_vat: "",
      d_vat_amount: "",
      d_wht_amount: "",
      d_wht_rate: "",
      d_pay_amount: "",
      d_payment_date: "",
      d_income_type: "",
      d_detail: "",
      d_receiver_bankcode: "",
      d_receiver_account_name: "",
      d_receiver_account_no: "",
      d_receiver_email: ""
    };
  },
  methods: {
    opentransactionmodal(transId) {
      this.currenttransaction = transId;
      this.transactionmodal = true;
    },
    async gettransaction() {
      this.istableloading = true;
      try {
        this.istableloading = true;
        let { data } = await this.axios.get(
          `${process.env.VUE_APP_APIHOST}/list_payoff`,
          {
            headers: {
              Authorization: this.$cookies.get("token")
            }
          }
        );
        this.alltransactions = data;
        // console.log(this.alltransactions);
        // if (this.role !== 'Super Admin'){
        //   // this.alltransactions = data.filter(bill => bill.company_name == this.selectedcpn)
        //   this.alltransactions = data[0].item_list
        //   console.log(this.alltransactions);
        // }
        // else{
        //   this.alltransactions = data[0].item_list
        //   console.log(this.alltransactions);

        // }

        this.istableloading = false;
      } catch (error) {
        this.istableloading = false;
        console.log(error.message);
      }
    },
    onExport() {
      const dataWS = XLSX.utils.json_to_sheet(this.alltransactions);
      const wb = XLSX.utils.book_new();
      XLSX.utils.book_append_sheet(wb, dataWS);
      XLSX.writeFile(wb, "Report.xlsx");
    },
    // createPDF () {
    // let pdfName = 'test';
    // var doc = new jsPDF();
    // doc.text(this.dataWS, 10, 10);
    // doc.save(pdfName + '.pdf');
    // },
    // savePdf(){
    //      let self = this;
    //     let jsonString = JSON.stringify(self.spread.toJSON());
    //     let printSpread = new GC.Spread.Sheets.Workbook();
    //     printSpread.fromJSON(JSON.parse(jsonString));
    //     printSpread.savePDF(function(blob) {
    //             // window.open(URL.createObjectURL(blob))
    //             FaverSaver.saveAs(blob,  'Hello.pdf')
    //             }, function(error) {
    //              console.log(error);
    //             }, {
    //             title: 'Print',
    //         });
    //  },

    addCommas(nStr) {
      nStr += "";
      var x = nStr.split(".");
      var x1 = x[0];
      var x2 = x.length > 1 ? "." + x[1] : "";
      var rgx = /(\d+)(\d{3})/;
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, "$1" + "," + "$2");
      }
      return x1 + x2;
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    },
    btnAdvancedSearch() {
      if (this.advancedstatus == false) {
        this.advancedstatus = true;
      } else {
        this.advancedstatus = false;
        this.reset();
      }
    },
    reset() {
      this.receiveraccountname = "";
      this.grandtotal = "";
      this.receiverbankcode = "";
      this.receivertaxid = "";
      this.detail = "";
      this.transferprocessing = "";
      this.rdprocessing = "";
      // this.date = new Date().toISOString().substr(0, 10);
      this.date = "";
    },
    setStatusColor(status) {
      if (status == "Completed") {
        return "#ECF8EA";
      } else if (status == "In process") {
        return "#FFF7D2";
      } else if (status == "Rejected") {
        return "#FBE5E4";
      } else {
        return "#EEEEEE";
      }
    },
    setTextColor(status) {
      if (status == "Completed") {
        return "#58A144";
      } else if (status == "In process") {
        return "#E9A016";
      } else if (status == "Rejected") {
        return "#D1392B";
      } else {
        return "#757575";
      }
    },
    resend(_pvno, _payment_no, _accountname, _accountno, _bankcode) {
      console.log('_payment_no',_payment_no)
      this.pvno = _pvno;
      this.payment_no = _payment_no;
      this.name = _accountname;
      this.account_no = _accountno;
      this.bankcode = _bankcode;
    },

    async onSave() {
      this.istableloading = true;
      console.log('>>>>',this.payment_no)
      try {
        this.istableloading = true;
        var { data } = await this.axios.post(
          `${process.env.VUE_APP_APIHOST}/resend_payoff`,
          {
            payment_no: this.payment_no,
            receiver_account_name: this.name,
            receiver_account_no: this.account_no,
            receiver_bank_code: this.bankcode,
            createBy: this.$cookies.get("createdBy")
          },
          {
            headers: {
              Authorization: this.$cookies.get("token")
            }
          }
        );
        if (data == "Success") {
          Swal.fire({
            title: "Completed",
            text: "",
            icon: "success",
            showConfirmButton: false,
            timer: 1500
          });
          setTimeout(() => {
            this.istableloading = false;
            this.dialog = false;
            this.resend_dialog = false;
            this.d_transfer_processing = "In process";
            this.d_receiver_account_name = this.name;
            this.d_receiver_account_no = this.account_no;
            this.d_receiver_bankcode = this.bankcode;
            this.gettransaction();
          }, 1800);
        } else {
          Swal.fire({
            title: data,
            text: "",
            icon: "error"
          });
          this.istableloading = false;
        }
      } catch (error) {
        this.istableloading = false;
        this.dialog = false;
        this.resend_dialog = false;
        console.log(error.message);
      }
    },
    openDialogDetail(props) {
      this.detail_dialog = true;
      this.d_payno = props.item.payment_no;
      this.d_docno = props.item.order_id;
      this.d_transfer_processing = props.item.transfer_processing;
      this.d_receiver_company = props.item.receiver_company;
      this.d_receiver_tax_id = props.item.receiver_tax_id;
      this.d_amount_exc_vat = props.item.amount_exc_vat;
      this.d_vat_amount = props.item.vat_amount;
      this.d_wht_amount = props.item.wht_amount;
      this.d_wht_rate = props.item.wht_rate;
      this.d_pay_amount = props.item.pay_amount;
      this.d_payment_date = props.item.payment_date;
      this.d_income_type = props.item.income_type;
      this.d_detail = props.item.detail;
      this.d_receiver_bankcode = props.item.receiver_bankcode;
      this.d_receiver_account_name = props.item.receiver_account_name;
      this.d_receiver_account_no = props.item.receiver_account_no;
      this.d_receiver_email = props.item.receiver_email;
    },
    openDialogResend() {
      this.resend_dialog = true;
      this.resend(
        this.d_docno,
        this.d_payno,
        this.d_receiver_account_name,
        this.d_receiver_account_no,
        this.d_receiver_bankcode
      );
    },
    closeDetailDialog() {
      this.detail_dialog = false;
      this.d_payno = "";
      this.d_docno = "";
      this.d_transfer_processing = "";
      this.d_receiver_company = "";
      this.d_receiver_tax_id = "";
      this.d_amount_exc_vat = "";
      this.d_vat_amount = "";
      this.d_wht_amount = "";
      this.d_wht_rate = "";
      this.d_pay_amount = "";
      this.d_payment_date = "";
      this.d_income_type = "";
      this.d_detail = "";
      this.d_receiver_bankcode = "";
      this.d_receiver_account_name = "";
      this.d_receiver_account_no = "";
      this.d_receiver_email = "";
    }
  },
  computed: {
    transview() {
      return this.alltransactions
        .filter(bill => {
          let gtotal = bill.grand_total.toString();
          let _date = moment(bill.payment_date).format("YYYY-MM-DD");
          this.paymentdate = _date.toString();

          let conditions = [
            bill.receiver_account_name.includes(this.receiveraccountname),
            gtotal.includes(this.grandtotal),
            bill.receiver_bankcode.includes(
              this.receiverbankcode.toUpperCase()
            ),
            bill.receiver_tax_id.includes(this.receivertaxid),
            bill.detail.includes(this.detail),
            bill.transfer_processing.includes(this.transferprocessing),
            bill.rd_processing.includes(this.rdprocessing),
            this.paymentdate.includes(this.date)
          ];
          return conditions.every(c => c);
        })
        .map(trans => {
          return {
            ...trans,
            due_date: moment(trans.due_date).format("DD/MM/YYYY"),
            pay_amount: this.addCommas(trans.pay_amount.toFixed(2)),
            vat_amount: this.addCommas(trans.vat_amount.toFixed(2)),
            grand_total: this.addCommas(trans.grand_total.toFixed(2)),
            wht_amount: this.addCommas(trans.wht_amount.toFixed(2)),
            payment_date:
              moment(trans.payment_date).format("YYYY-MM-DD") +
              " " +
              trans.payment_time.substr(0, 2) +
              ":" +
              trans.payment_time.substr(2, 2) +
              ":" +
              trans.payment_time.substr(4, 6)
            // payment_time:
            //   trans.payment_time.substr(0, 2) +
            //   ":" +
            //   trans.payment_time.substr(2, 2) +
            //   ":" +
            //   trans.payment_time.substr(4, 6)
          };
        });
    },
    transactionmodal: sync("transactionmodal"),
    currenttransaction: sync("currenttransaction"),
    tokenHashTaxid: sync("tokenHashTaxid"),
    exportmodal: sync("exportmodal"),
    exportfrom: sync("exportfrom"),
    computedDateFormattedMomentjs() {
      return this.date ? moment(this.date).format("YYYY-MM-DD") : "";
    }

    // selectedcpn: sync('selectedcpn')
  },
  created() {
    if (
      (this.role == "User" && this.$cookies.get("token")) ||
      (this.role == "Admin" && this.$cookies.get("token"))
    ) {
      this.gettransaction();
    }
    this.handleView();
    window.addEventListener("resize", this.handleView);
  },
  watch: {
    // selectedcpn(){
    //   this.gettransaction()
    // },
    tokenHashTaxid(data) {
      // console.log('transaction tokenHashTaxid: ', data)
      this.gettransaction();
    }
  }
};
</script>

<style scoped>
.datetime {
  width: 150px;
  height: 150px;
}

/* .v-text-field--outline > .v-input__control > .v-input__slot {
  border: 1px solid #e0e0e0 !important;
} */

.btn-advanced-search {
  font-style: normal;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #3a8300 !important;
  border-radius: 4px;
  margin: 16px 0px 16px 0px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}

.btn-export {
  background: #3a8300 !important;
  border-radius: 4px;
  color: white;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  text-transform: none;
  margin: 16px 0px 16px 0px;
  font-family: "Sarabun", sans-serif;
}

.text {
  font-size: 14px;
  line-height: 22px;
  color: #212121;
  font-family: "Sarabun", sans-serif;
}

::v-deep
  .v-select.v-text-field--enclosed:not(.v-text-field--single-line)
  .v-select__selections {
  padding-top: 0px;
}

/* ::v-deep
  .theme--light.v-text-field--outline
  > .v-input__control
  > .v-input__slot {
  border: 2px solid #e0e0e0;
} */

.box-advanced {
  border: 1px solid #d2e7c2;
  box-sizing: border-box;
  box-shadow: 0px 4px 6px rgba(233, 251, 219, 0.15);
  border-radius: 4px !important;
  margin: 0px 34px 16px 34px;
}

.btn-reset {
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #d1392b;
  border-radius: 4px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}

::v-deep .v-list__tile__title {
  color: black;
}

.btn-resend {
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #d1392b;
  border-radius: 4px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}

.btn-resend2 {
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #ffffff;
  background-color: #d1392b !important;
  border-radius: 4px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}

.btn-save {
  background-color: #58a144 !important;
  color: white;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  border-radius: 4px;
  text-transform: none;
}

.title {
  font-weight: bold;
  font-size: 26px !important;
  font-family: "Sarabun", sans-serif !important;
}

.text-dialog {
  font-size: 18px;
  font-family: "Sarabun", sans-serif !important;
}

.text-head {
  font-weight: bold;
}

.text-detail {
  padding-left: 30px;
}
</style>
